Assumption of length field size in workaround for wrong attribute VR
Description

The dcmdata parser has the possibility to override the wrong VR given in a DICOM file for an attribute by the official dictionary
definition. See option "-ev" in current dcmdump code.

However, the assumption about the size of the length field (2 byte versus 4 bytes) is not corrected, i.e. the parser selects the correct
VR, but does keep the wrong length field size if it was different for the wrong VR for that attribute.

Instead, the parser should also consider that the length field size may have changed too, in order to parse the attribute correctly.
Maybe both behaviours make sense, so think whether this is worth an extra option.

History

#1 - 2012-11-27 15:55 - Uli Schlachter

- File useDictForLengthField.patch added

The current behavior seems to be the way it is on purpose: (dcitem.cc, line 966)

/* determine VR read from dataset, because this VR specifies the number of bytes for the length-field */
Attached patch should implement the requested behavior. However, it is completely untested (this is definitely something that needs unit tests!)

#2 - 2012-12-04 16:55 - Uli Schlachter
- File useDictForLengthField2.patch added

#3 - 2012-12-11 09:44 - Uli Schlachter
- % Done changed from 0 to 80

The parser-related parts of this are implemented with commit 7a4dc9fa31058dd675b7cf2fc62d58c904aba3f9.
Does anyone else want to add the command line options for this to the various tools?
#4 - 2017-03-10 16:44 - Marco Eichelberg

- Status changed from New to Closed

- % Done changed from 80 to 100

It does not make sense to add command line options to tools other than dcmdump and demconv, which both support the --ignore-explicit-vr and can
thus be used for debugging and fixing files with incorrect VRs. It also does not make much sense in my view to add a command line option to enable
the demPreferLengthFieldSizeFromDataDictionary flag, which re-enables an incorrect behaviour of the parser. Closing bug.

Files
useDictForLengthField.patch 1.12 KB 2012-11-27 Uli Schlachter
useDictForLengthField2.patch 9.95 KB 2012-12-04 Uli Schlachter
